<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
	<html>
	<body text="#000000" vlink="#FF3300" link="#FF3300" bgcolor="#ffffff">
	<font face="Verdana,Arial,Helvetica" size="2">
	<xsl:apply-templates select="//*"/>
	</font>
	</body>
	</html>
</xsl:template>

<xsl:template match="*">
	<!--  List the attribute names and values. --> 
	
		<!-- CheckBox -->
		<xsl:if test="@App='Option'">
			<input type="hidden" value="">
				<xsl:attribute name="name"><xsl:value-of select="name()"/></xsl:attribute>
			</input>
			<input type="checkbox">
				<xsl:attribute name="name"><xsl:value-of select="name()"/></xsl:attribute>
				<xsl:if test=".=1">
					<xsl:attribute name="checked">on</xsl:attribute>
				</xsl:if>
			</input>
		    <xsl:if test="not(starts-with(name(),'_'))">
			<strong>
				<xsl:call-template name="string-replace-underscores">
					<xsl:with-param name="text" select="name()"/>
				</xsl:call-template>
			</strong>
			</xsl:if>
			<i> (default: <xsl:value-of select="@Default"/>)</i>
			<br/>
		</xsl:if>

		<!-- Select -->
		<xsl:if test="@App='Select'">
			<select>
				<xsl:attribute name="name"><xsl:value-of select="name()"/></xsl:attribute>
				<xsl:call-template name="selection">
					<xsl:with-param name="text" select="@Display"/>
					<xsl:with-param name="separator" select="';'"/>
					<xsl:with-param name="index" select="'0'"/>
					<xsl:with-param name="selectedindex" select="."/>
				</xsl:call-template>
			</select>
		    <xsl:if test="not(starts-with(name(),'_'))">
			<strong><xsl:text> </xsl:text>
				<xsl:call-template name="string-replace-underscores">
					<xsl:with-param name="text" select="name()"/>
				</xsl:call-template>
			</strong>
			</xsl:if>
			<i> (default: <xsl:value-of select="@Default"/>)</i>
			<br/>
		</xsl:if>
		
		<!-- TextBox -->
		<xsl:if test="@App='Text'">
		    <xsl:if test="not(starts-with(name(),'_'))">
			<strong>
				<xsl:call-template name="string-replace-underscores">
					<xsl:with-param name="text" select="name()"/>
				</xsl:call-template>
			</strong>:
			</xsl:if>
			<input type="text" size="30" value="{.}">
				<xsl:attribute name="name"><xsl:value-of select="name()"/></xsl:attribute>
			</input><i> (default: <xsl:value-of select="@Default"/>)</i>
			<br/>
		</xsl:if>

		<!-- List -->
		<xsl:if test="@App='List'">
		    <xsl:if test="not(starts-with(name(),'_'))">
			<strong>
				<xsl:call-template name="string-replace-underscores">
					<xsl:with-param name="text" select="name()"/>
				</xsl:call-template>
			</strong>
			<br/>
			</xsl:if>
			<textarea style="width:400px;height:120px;">
				<xsl:attribute name="name"><xsl:value-of select="name()"/></xsl:attribute>
				<xsl:call-template name="listing" />
			</textarea>
			<br/>
		</xsl:if>

		<!-- Map -->
		<xsl:if test="@App='Map'">
		    <xsl:if test="not(starts-with(name(),'_'))">
			<strong>
				<xsl:call-template name="string-replace-underscores">
					<xsl:with-param name="text" select="name()"/>
				</xsl:call-template>
			</strong>
			<br/>
			</xsl:if>
			<textarea style="width:500px;height:120px;">
				<xsl:attribute name="name"><xsl:value-of select="name()"/></xsl:attribute>
				<xsl:call-template name="mapping" />
			</textarea>
			<br/>
		</xsl:if>

		<!-- Separator -->
		<xsl:if test="@App='Separator'">
			<h2>
				<xsl:call-template name="string-replace-underscores">
					<xsl:with-param name="text" select="name()"/>
				</xsl:call-template>
			</h2>
			<hr/>
		</xsl:if>

		<!-- Document -->
		<xsl:if test="@App='Document'">
			<!-- is for config.exe -->
		</xsl:if>

		<!-- Title -->
		<xsl:if test="@App='Title'">
			<div align="center">
			<h2>
				<xsl:call-template name="string-replace-underscores">
					<xsl:with-param name="text" select="name()"/>
				</xsl:call-template>
			</h2>
			</div>
		</xsl:if>
		
		<!-- Explanation -->
		<xsl:if test="@Explanation!=''">
			<xsl:value-of select="@Explanation"/>
			<br/>
			<br/>
		</xsl:if>

</xsl:template>

<!-- CRLF needs to be before node value, because first empty Item element is otherwise stripped -->
<xsl:template name="listing">
	<xsl:for-each select="*">
		<xsl:text>&#xD;&#xA;</xsl:text><xsl:value-of select="."/>
	</xsl:for-each>
</xsl:template>

<xsl:template name="mapping">
	<xsl:for-each select="*">
		<xsl:if test="name()='Key'">
			<xsl:value-of select="."/>=<xsl:value-of select="following-sibling::Val"/><xsl:text>&#xD;&#xA;</xsl:text>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="string-replace-underscores">
    <xsl:param name="text"/>
    <xsl:call-template name="string-replace-all">
      <xsl:with-param name="text" select="$text"/>
      <xsl:with-param name="replace" select="'_'"/>
      <xsl:with-param name="by" select="' '"/>
    </xsl:call-template>
</xsl:template>

<xsl:template name="string-replace-all">
    <xsl:param name="text"/>
    <xsl:param name="replace"/>
    <xsl:param name="by"/>
    <xsl:choose>
      <xsl:when test="contains($text, $replace)">
        <xsl:value-of select="substring-before($text,$replace)"/>
        <xsl:value-of select="$by"/>
        <xsl:call-template name="string-replace-all">
          <xsl:with-param name="text" select="substring-after($text,$replace)"/>
          <xsl:with-param name="replace" select="$replace"/>
          <xsl:with-param name="by" select="$by"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$text"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
 	
<xsl:template name="selection">
  <xsl:param name="text"/>
  <xsl:param name="separator"/>
  <xsl:param name="index"/>
  <xsl:param name="selectedindex"/>

  <xsl:if test="string-length($text)">
   <xsl:variable name="token" select=
    "substring-before(concat($text,$separator), $separator)"/>
   <option>
	   <xsl:attribute name="value"><xsl:value-of select="$index"/></xsl:attribute>
	   <xsl:if test="$selectedindex=$index">
			<xsl:attribute name="selected">on</xsl:attribute>
	   </xsl:if>
	   <xsl:value-of select="$token"/>
   </option>

   <xsl:call-template name="selection">
    <xsl:with-param name="text" select="substring-after($text, $separator)"/>
    <xsl:with-param name="separator" select="$separator"/>
    <xsl:with-param name="index" select="$index + 1"/>
    <xsl:with-param name="selectedindex" select="$selectedindex"/>
   </xsl:call-template>
  </xsl:if>
 </xsl:template>
 
</xsl:stylesheet>