<% Option Explicit %><html>
<head>
<title>AQTRONIX XML Editor</title>
</head>
<body text="#000000" vlink="#FF3300" link="#FF3300" bgcolor="#ffffff">
<font face="Verdana,Arial,Helvetica" size="2">
<%
 ' This application allows you to edit the configuration files using a browser
 ' This file is called from within the /WebKnight/ admin url if enabled.
 '
 ' You can also add a new web site in IIS and map it to this folder.
 ' Make sure you limit the IP addresses or use authentication to prevent
 ' unauthorized access to your configuration files

Select Case True
	Case Request.Querystring("update")="Robots"
		'update robots.xml
		DownloadFile "http://www.aqtronix.com/downloads/WebKnight/Robots/Robots.xml", CurrentPath & "Robots.xml"
	Case Request.Querystring("diag")="ServerVariables"
		ServerVariables()
	Case Else
		Dim File
		File = Request.Querystring("file")	
		If Not IsValidConfigFile(File) Then
			'show menu
			Response.Write "<h2>AQTRONIX XML Editor</h2>"

			'directory listing
			ShowListing CurrentPath
			
			'Update robots.xml
			%><br/><a href="default.asp?update=Robots">Update Robots Database</a><br/><br/><%
		Else %>
			<form method="post" action="default.asp?file=<%= Server.URLEncode(File) %>"><%
			'update file
			If Request.Form("btn_sub")<>"" Then
			  UpdateFile CurrentPath & File
			End If

			'show GUI
			LoadFile CurrentPath & File, CurrentPath & "GUI.xsl"
			If Left(File,7)<>"Loaded." Then %>
				<input type="submit" id="btn_sub" name="btn_sub" value="Submit"/>
				<input type="reset" id="btn_reset" name="btn_reset" value="Reset"/><%
			End If %>
			</form><%
		End If
End Select
%>
<hr/>
<i>AQTRONiX XML Editor - Copyright &copy; 2013-2015 AQTRONiX, Parcifal Aertssen</i>
</font>
</body>
</html>
<%

'based on: http://www.w3schools.com/xsl/xsl_editxml.asp
Function LoadFile(xmlfile,xslfile)
	Dim xmlDoc,xslDoc
	'Load XML file
	Set xmlDoc = Server.CreateObject("Microsoft.XMLDOM")
	xmlDoc.async = false
	xmlDoc.load(xmlfile)
	'Load XSL file
	Set xslDoc = Server.CreateObject("Microsoft.XMLDOM")
	xslDoc.async = false
	xslDoc.load(xslfile)
	'Transform file
	Response.Write(xmlDoc.transformNode(xslDoc))
End Function

Function UpdateFile(xmlfile)
	Dim xmlDoc,rootEl,f,i,value, values, el, pos, key, keyval, v
	'Load XML file
	Set xmlDoc = Server.CreateObject("Microsoft.XMLDOM")
	xmlDoc.async = False
	xmlDoc.load(xmlfile)

	'Set the rootEl variable equal to the root element
	Set rootEl = xmlDoc.documentElement

	'Loop through the form collection
	For i = 1 To Request.Form.Count
	  'Eliminate button elements in the form
	  If InStr(Request.Form.Key(i),"btn_")=0 Then
		Set f = rootEl.selectSingleNode(Request.Form.Key(i))
		value = Request.Form(i)
		'Response.Write Request.Form.Key(i) & ":" & value & "<br/>"
		If Not f Is Nothing Then
			Select Case f.getAttribute("App")
			Case "Option"
				If InStr(value,"on")>0 Then
					f.text = "1"
				Else
					f.text = "0"
				End If
			Case "Select"
				f.Text = value
			Case "Text"
				f.Text = value
			Case "List"
				'delete children
				While f.childNodes.Length>0
					f.removeChild(f.childNodes(0))
				Wend
				'add children
				value = RemoveTrailingCRLF(value)'remove trailing CRLF from users
				values = Split(value,vbCRLF)
				For Each v In values
					Set el = xmlDoc.createElement("Item")
					el.Text = v
					f.appendChild(el)
				Next
			Case "Map"
				'delete children
				While f.childNodes.Length>0
					f.removeChild(f.childNodes(0))
				Wend
				'add children
				value = RemoveTrailingCRLF(value)'remove trailing CRLF from users
				values = Split(value,vbCRLF)
				For Each v In values
					pos = InStr(v,"=")
					If pos>0 Then
						key = Left(v,pos-1)
						keyval = Mid(v,pos+1)
						Set el = xmlDoc.createElement("Key")
						el.Text = key
						f.appendChild(el)
						Set el = xmlDoc.createElement("Val")
						el.Text = keyval
						f.appendChild(el)
					End If
				Next
			End Select
		End If
	  End If
	Next

	'Save the modified XML file
	xmlDoc.save xmlfile

	'Release all object references
	Set xmlDoc=Nothing
	Set rootEl=Nothing
	Set f=Nothing
End Function

Function RemoveTrailingCRLF(text)
	'remove trailing CRLF from GUI.xsl
	If Right(text,2) = vbCRLF Then
		RemoveTrailingCRLF = Left(text,Len(text)-2)
	Else
		RemoveTrailingCRLF = text
	End If
End Function

Function DownloadFile(Url,Filename)
	Dim objXMLHTTP, objADOStream, objFSO
	Response.Write "Downloading from " & Server.HTMLEncode(Url) & "<br/>"
	Set objXMLHTTP = CreateObject("MSXML2.XMLHTTP")

	objXMLHTTP.open "GET", Url, False
	objXMLHTTP.send()

	Response.Write "Server Status: " & objXMLHTTP.Status & "<br/>"
	If objXMLHTTP.Status = 200 Then
		On Error Resume Next
		Set objADOStream = CreateObject("ADODB.Stream")
		objADOStream.Open
		objADOStream.Type = 1 'adTypeBinary

		objADOStream.Write objXMLHTTP.ResponseBody
		objADOStream.Position = 0 'Set the stream position to the start

		Set objFSO = Createobject("Scripting.FileSystemObject")
		If objFSO.FileExists(Filename) Then objFSO.DeleteFile Filename
		Set objFSO = Nothing

		Response.Write "Saving to " & Server.HTMLEncode(Filename) & "<br/>"
		objADOStream.SaveToFile Filename
		objADOStream.Close
		Set objADOStream = Nothing
		If Err Then
			Response.Write "Error: " & Err.Description & "<br/>"
		Else
			Response.Write "Success!<br/>"
		End If
	Else
		Response.Write "Failed to download file<br/>"
	End if

	Set objXMLHTTP = Nothing
End Function

Sub ShowListing(Path)
	Dim fso, Root, Files, f
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	Set Root = fso.getfolder(Path)
	Set Files = Root.Files
	For Each f In Files
		If UCase(fso.GetExtensionName(f.Name)) = "XML" Then
			Response.write "<li><a href=""default.asp?file=" & Server.URLEncode(f.Name) & """>" & Server.HTMLEncode(f.Name) & "</a></li>"
		End If
	Next	
	Set fso = Nothing
	Set Root = Nothing
	Set Files = Nothing
End Sub

Function IsValidConfigFile(File)
	If File="" Then
		IsValidConfigFile = False
	Else
		IsValidConfigFile = InStr(File,"..")=0 And InStr(File,"/")=0 And InStr(File,"\")=0 And UCase(Right(File,4))=".XML"
	End If
End Function

Function CurrentPath()
	CurrentPath = Request.ServerVariables("PATH_TRANSLATED") 'redirected from within WebKnight, cannot use Server.MapPath(".")
	Dim pos
	pos = InStrRev(CurrentPath,"\")
	If pos>0 Then
		CurrentPath = Left(CurrentPath,pos)
	End If
End Function

Sub ServerVariables
	Response.Write "<h1>Variables</h1>"
	Dim x
	For Each x in Request.ServerVariables
	  %><strong><%= Server.HTMLEncode(x) %></strong>: <%= Server.HTMLEncode(Request.ServerVariables(x)) %><br><%
	Next
End Sub
%> 