/*
    AQTRONIX C++ Library
    Copyright 2005-2006 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// WebAgents.h: interface for the CWebAgents class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEBAGENTS_H__E994FF85_60F2_4154_8686_146485A4CFD6__INCLUDED_)
#define AFX_WEBAGENTS_H__E994FF85_60F2_4154_8686_146485A4CFD6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Settings.h"

class CWebAgents : public CSettings  
{
public:

#define WEBAGENTS_MEMBERS(name)\
	CStringList UserAgents##name;\
	CStringList UserAgents##name##Sequences;\
	CStringList IPAddresses##name;

	
	WEBAGENTS_MEMBERS(DataMiningPublic)
	WEBAGENTS_MEMBERS(DataMiningCommercial)
	WEBAGENTS_MEMBERS(DownloadManagers)
	WEBAGENTS_MEMBERS(EmailHarvesting)
	WEBAGENTS_MEMBERS(GuestbookSpammers)
	WEBAGENTS_MEMBERS(HackTools)
	WEBAGENTS_MEMBERS(ImageDownloaders)
	WEBAGENTS_MEMBERS(Indexing)
	WEBAGENTS_MEMBERS(Monitoring)
	WEBAGENTS_MEMBERS(OfflineBrowsers)
	WEBAGENTS_MEMBERS(OtherBad)
	WEBAGENTS_MEMBERS(Trademark)
	WEBAGENTS_MEMBERS(ValidationTools)
	WEBAGENTS_MEMBERS(LinkChecking)
	WEBAGENTS_MEMBERS(Browsers)
	WEBAGENTS_MEMBERS(MediaPlayers)
	WEBAGENTS_MEMBERS(Proxies)
	WEBAGENTS_MEMBERS(Adware)
	WEBAGENTS_MEMBERS(BrowserExtensions)
	WEBAGENTS_MEMBERS(Spyware)
	WEBAGENTS_MEMBERS(Editing)
	WEBAGENTS_MEMBERS(Device)
	WEBAGENTS_MEMBERS(NewsFeed)
	WEBAGENTS_MEMBERS(SearchEngines)
	WEBAGENTS_MEMBERS(FilteringSoftware)
	WEBAGENTS_MEMBERS(SoftwareComponent)
	WEBAGENTS_MEMBERS(Translation)

	CString ToXML();
	bool ParseXML(CString& key, CString& val);
	bool WriteToFileINI(LPCSTR fn);
	bool ReadFromFileINI(LPCTSTR fn);
	bool WriteToFileXML(LPCTSTR fn);
	void LoadDefaults();
	bool CheckConstraints();

	CWebAgents();
	virtual ~CWebAgents();

};

#endif // !defined(AFX_WEBAGENTS_H__E994FF85_60F2_4154_8686_146485A4CFD6__INCLUDED_)
